Index: code/branches/weaponupdateHS14/data/levels/FPS_Level_HS14.oxw
===================================================================
--- code/branches/weaponupdateHS14/data/levels/FPS_Level_HS14.oxw	(revision 10177)
+++ code/branches/weaponupdateHS14/data/levels/FPS_Level_HS14.oxw	(revision 10178)
@@ -51,8 +51,29 @@
     <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0,1.0,1.0,0.5" specular="1.0, 0.9, 0.9, 1.0"/>
     
-    <SpawnPoint team=1 position="3000,0,0" lookat="4000,-1000,-1000" spawnclass=SpaceShip pawndesign=spaceshipescort />
-	<!--6000,2000,500-->
-	
-
+    <SpawnPoint team=1 position="6000,2000,500" lookat="4000,-1000,-1000" spawnclass=SpaceShip pawndesign=spaceshipescort />
+	<!--Position normal Level: "6000,2000,500"; postion for work at the spacesation: "3000,0,0 "-->
+	
+	<!--1,200,0-->
+	<SpaceShip			
+        template            = "spaceshipassff"
+        team                = "1"
+        position            = "3337,-19,-320"
+        orientation         = "5800,-200,-1200,0"
+        health              = "200"
+        initialhealth       = "200"
+        maxhealth           = "200"
+        shieldhealth        = "50"
+        initialshieldhealth = "50"
+        maxshieldhealth     = "50"
+        shieldabsorption    = "0.8"
+        reloadrate          = "100"
+        reloadwaittime      = "0.1"
+        name                = "Tanis1"
+        radarname           = "Light Destroyer" >
+		<attached>
+        	<DockingTarget name="spaceShip" />
+        	<DistanceTriggerBeacon name="bcnSpaceShip" />
+		</attached>
+    </SpaceShip>
 	
 	
@@ -83,5 +104,5 @@
 
 
-	<!-- Docking  -->
+	<!-- Docking I -->
 	    <Dock position="2830,20,50" roll=0 yaw=0 >
 	        <animations>
@@ -108,6 +129,6 @@
 	            />
 		<!-- Trigger for undocking with billboard -2800,-20055,-700-->
-		    <Billboard position="-1500,-20100,-50" material="Flares/ringflare2" colour="0.2,0.4,0.8" scale=1 />
-		    <DistanceTrigger position="-1500,-20100,-50" distance="150" target="Pawn"
+		    <Billboard position="-1500,-20021,-50" material="Flares/ringflare2" colour="0.2,0.4,0.8" scale=1 />
+		    <DistanceTrigger position="-1500,-20021,-50" distance="150" target="Pawn"
 	                beaconMode="identify" targetname="bcnDestroyer" name="undockMe"
 	            />
@@ -129,5 +150,5 @@
 
 	<!-- Docking  II -->
-	    <Dock position="86,-20055,-700" roll=0 yaw=0 >
+	    <Dock position="86,-20005,-700" roll=0 yaw=0 >
 	        <animations>
 	            <MoveToDockingTarget target="spaceShip" />
@@ -148,11 +169,11 @@
 	        <attached>
 		<!-- Trigger for docking with billboard -->
-	            <Billboard position="0,50,0" material="Flares/ringflare2" colour="0.3,0.4,0.5" scale=1 />
+	            <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.3,0.4,0.5" scale=1 />
 	            <DistanceTrigger position="0,0,0" distance="100" target="Pawn"
 	                beaconMode="exclude" targetname="bcnSpaceShip" name="dockMe"
 	            />
 		<!-- Trigger for undocking with billboard -->
-		    <Billboard position="3251,20036,380" material="Flares/ringflare2" colour="0.3,0.4,0.5" scale=1 />
-		    <DistanceTrigger position="3251,20036,380" distance="100" target="Pawn"
+		    <Billboard position="3251,20006,380" material="Flares/ringflare2" colour="0.3,0.4,0.5" scale=1 />
+		    <DistanceTrigger position="3251,20006,380" distance="100" target="Pawn"
 	                beaconMode="identify" targetname="bcnSpaceShip" name="undockMe"
 	            />
@@ -161,29 +182,8 @@
 	
 
-	<SpaceShip			
-        template            = "spaceshipAssff"
-        team                = "0"
-        position            = "3337,-19,-320"
-        orientation         = "1,200,0,0"
-        health              = "200"
-        initialhealth       = "200"
-        maxhealth           = "200"
-        shieldhealth        = "50"
-        initialshieldhealth = "50"
-        maxshieldhealth     = "50"
-        shieldabsorption    = "0.8"
-        reloadrate          = "1"
-        reloadwaittime      = "1"
-        name                = "Tanis1"
-        radarname           = "Light Destroyer" >
-       <attached>
-        <DockingTarget name="spaceShip" />
-        <DistanceTriggerBeacon name="bcnSpaceShip" />
-      </attached>
-    </SpaceShip>
 
  <!-- Enemy ships -->
  
-<!--	<SpaceShip			
+ 	<SpaceShip			
         template            = "HeavyCruiser"
         team                = "0"
@@ -202,10 +202,10 @@
         radarname           = "Tanis big ship" >
    </SpaceShip>
-    -->
+		-->
     
- <!--   <SpaceShip			
+	<SpaceShip			
         template            = "spaceshippirate"
         team                = "0"
-        position            = "4800,-200,-1200"
+        position            = "11000,0,-2500"
         orientation         = "1,200,0,0"
         health              = "200"
@@ -230,5 +230,5 @@
         template            = "spaceshippirate"
         team                = "0"
-        position            = "4800,-220,-1200"
+        position            = "11000,0,-2500"
         orientation         = "1,200,0,0"
         health              = "200"
@@ -249,5 +249,5 @@
         
    </SpaceShip>
-   -->
+	
 
 <!-- SpaceStation
Index: code/branches/weaponupdateHS14/data/levels/templates/FPS.oxt
===================================================================
--- code/branches/weaponupdateHS14/data/levels/templates/FPS.oxt	(revision 10177)
+++ code/branches/weaponupdateHS14/data/levels/templates/FPS.oxt	(revision 10178)
@@ -21,6 +21,6 @@
    weapon            = "hs-w01.mesh"
   >
-    <collisionShapes>
-      <BoxCollisionShape position="0,-20,0" halfExtents="15,25,15" />
+    <collisionShapes>			<!-- old values: position="0,-20,0"  halfExtents="15,25,15"  -->
+      <BoxCollisionShape position="0,-25,0" halfExtents="15,20,15" />
     </collisionShapes>
 
Index: code/branches/weaponupdateHS14/data/levels/templates/FPS_HS14.oxt
===================================================================
--- code/branches/weaponupdateHS14/data/levels/templates/FPS_HS14.oxt	(revision 10177)
+++ code/branches/weaponupdateHS14/data/levels/templates/FPS_HS14.oxt	(revision 10178)
@@ -22,5 +22,5 @@
   >
     <collisionShapes>
-   <!--Normal values: position="0,-20,0" halfExtents="15,25,15" -->
+   <!--Normal values: position="0,-45,0" halfExtents="15,50,15" -->
       <BoxCollisionShape position="0,-45,0" halfExtents="15,50,15" /> 
     </collisionShapes>