Index: /branches/data_fix/src/lib/graphics/importer/md3/md3_data.cc
===================================================================
--- /branches/data_fix/src/lib/graphics/importer/md3/md3_data.cc	(revision 10185)
+++ /branches/data_fix/src/lib/graphics/importer/md3/md3_data.cc	(revision 10186)
@@ -425,5 +425,5 @@
     std::string path1(tex[i].fileName);
     std::string fullPath( path + path1);
-    this->meshes[mesh]->material[i].setDiffuseMap(/*tex[i].fileName*/ /*fullPath.c_str()*/ "maps/creatures/gork/gorkup.tga");
+    this->meshes[mesh]->material[i].setDiffuseMap(/*tex[i].fileName*/ /*fullPath.c_str()*/ "textures/creatures/gork/gorkup.tga");
     this->meshes[mesh]->material[i].setAmbient(1, 1, 1);
   }
Index: /branches/data_fix/src/world_entities/effects/explosion.cc
===================================================================
--- /branches/data_fix/src/world_entities/effects/explosion.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/effects/explosion.cc	(revision 10186)
@@ -79,5 +79,5 @@
     Explosion::explosionParticles = new SpriteParticles(5000);
     Explosion::explosionParticles->setName("ExplosionExplosionParticles");
-    Explosion::explosionParticles->setMaterialTexture("maps/radial-trans-noise.png");
+    Explosion::explosionParticles->setMaterialTexture("textures/radial-trans-noise.png");
     Explosion::explosionParticles->setLifeSpan(1.5, .3);
     Explosion::explosionParticles->setRadius(0.0, 10);
Index: /branches/data_fix/src/world_entities/effects/lightning_bolt.cc
===================================================================
--- /branches/data_fix/src/world_entities/effects/lightning_bolt.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/effects/lightning_bolt.cc	(revision 10186)
@@ -44,5 +44,5 @@
 
   this->material = new Material();
-  this->material->setDiffuseMap("maps/lightning_bolt.png");
+  this->material->setDiffuseMap("textures/lightning_bolt.png");
   //this->offset = Vector(-1440.00, 100.00, 280.00);
 
@@ -58,5 +58,5 @@
   this->soundSource.setSourceNode(this);
 
-  this->thunderBuffer = OrxSound::ResourceSoundBuffer("sound/atmosphere/thunder.wav");
+  this->thunderBuffer = OrxSound::ResourceSoundBuffer("sounds/atmosphere/thunder.wav");
 }
 
Index: /branches/data_fix/src/world_entities/elements/glgui_energywidget.cc
===================================================================
--- /branches/data_fix/src/world_entities/elements/glgui_energywidget.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/elements/glgui_energywidget.cc	(revision 10186)
@@ -37,12 +37,12 @@
     this->_valueText.setChangedTextColor(Color::white);
 
-    //this->setBackgroundTexture("maps/gui_element_background_2.png");
+    //this->setBackgroundTexture("textures/gui/gui_element_background_2.png");
     this->setBackgroundColor(Color(.5,.5,.5,1));
 
     //this->_name.setBackgroundTexture(Texture());
-    //this->_valueText.setBackgroundTexture("maps/gui_element_background_2.png");
+    //this->_valueText.setBackgroundTexture("textures/gui/gui_element_background_2.png");
     this->_bar.setBackgroundTexture(Texture());
     this->_bar.setBackgroundColor(Color(0,0,0,0));
-    this->_bar.setForegroundTexture("maps/gui_element_background_faded.png");
+    this->_bar.setForegroundTexture("textures/gui/gui_element_background_faded.png");
     this->_bar.setForegroundColor(Color(.5, .5, .5, 1));
     this->_bar.setChangedValueColor(Color::black);
Index: /branches/data_fix/src/world_entities/particles/dot_particles.cc
===================================================================
--- /branches/data_fix/src/world_entities/particles/dot_particles.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/particles/dot_particles.cc	(revision 10186)
@@ -64,5 +64,5 @@
   this->registerObject(this, DotParticles::_objectList);
 
-  this->material.setDiffuseMap("maps/radial-trans-noise.png");
+  this->material.setDiffuseMap("textures/radial-trans-noise.png");
 }
 
Index: /branches/data_fix/src/world_entities/particles/model_particles.cc
===================================================================
--- /branches/data_fix/src/world_entities/particles/model_particles.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/particles/model_particles.cc	(revision 10186)
@@ -31,5 +31,5 @@
 
 SHELL_COMMAND(texture, ModelParticles, setMaterialTexture)
-->defaultValues("maps/evil-flower.png");
+->defaultValues("textures/evil-flower.png");
 
 
Index: /branches/data_fix/src/world_entities/particles/sprite_particles.cc
===================================================================
--- /branches/data_fix/src/world_entities/particles/sprite_particles.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/particles/sprite_particles.cc	(revision 10186)
@@ -30,5 +30,5 @@
 
 SHELL_COMMAND(texture, SpriteParticles, setMaterialTexture)
-    ->defaultValues("maps/evil-flower.png");
+    ->defaultValues("textures/evil-flower.png");
 
 
@@ -69,5 +69,5 @@
   this->registerObject(this, SpriteParticles::_objectList);
 
-  this->material.setDiffuseMap("maps/radial-trans-noise.png");
+  this->material.setDiffuseMap("textures/radial-trans-noise.png");
 }
 
Index: /branches/data_fix/src/world_entities/weapons/aim.cc
===================================================================
--- /branches/data_fix/src/world_entities/weapons/aim.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/weapons/aim.cc	(revision 10186)
@@ -43,5 +43,5 @@
     this->loadParams(root);
   else
-    this->setTexture("maps/aim.png");
+    this->setTexture("textures/aim.png");
 }
 
Index: /branches/data_fix/src/world_entities/weapons/crosshair.cc
===================================================================
--- /branches/data_fix/src/world_entities/weapons/crosshair.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/weapons/crosshair.cc	(revision 10186)
@@ -37,5 +37,5 @@
     this->loadParams(root);
   else
-    this->setTexture("maps/aim.png");
+    this->setTexture("textures/aim.png");
 }
 
Index: /branches/data_fix/src/world_entities/weapons/fps_sniper_rifle.cc
===================================================================
--- /branches/data_fix/src/world_entities/weapons/fps_sniper_rifle.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/weapons/fps_sniper_rifle.cc	(revision 10186)
@@ -84,5 +84,5 @@
   this->material->setIllum(3);
   this->material->setAmbient(1.0, 1.0, 1.0);
-  this->material->setDiffuseMap("maps/rifle01tex.jpg");
+  this->material->setDiffuseMap("textures/rifle01tex.jpg");
 
   this->setStateDuration(WS_SHOOTING, .1);
@@ -95,6 +95,6 @@
   //this->minCharge = 2;
 
-  this->setActionSound(WA_SHOOT, "sound/laser.wav");
-  this->setActionSound(WA_ACTIVATE, "sound/voices/lasers.wav");
+  this->setActionSound(WA_SHOOT, "sounds/laser.wav");
+  this->setActionSound(WA_ACTIVATE, "sounds/voices/lasers.wav");
 
 
Index: /branches/data_fix/src/world_entities/weather_effects/lightning_effect.cc
===================================================================
--- /branches/data_fix/src/world_entities/weather_effects/lightning_effect.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/weather_effects/lightning_effect.cc	(revision 10186)
@@ -263,14 +263,14 @@
 
   if (this->thunderTextureA) {
-    this->thunderBolt[0]->setTexture("maps/thunderbA1.png");
-    this->thunderBolt[1]->setTexture("maps/thunderbA2.png");
-    this->thunderBolt[2]->setTexture("maps/thunderbA3.png");
-    this->thunderBolt[3]->setTexture("maps/thunderbA4.png");
+    this->thunderBolt[0]->setTexture("textures/thunderbA1.png");
+    this->thunderBolt[1]->setTexture("textures/thunderbA2.png");
+    this->thunderBolt[2]->setTexture("textures/thunderbA3.png");
+    this->thunderBolt[3]->setTexture("textures/thunderbA4.png");
   }
   else {
-    this->thunderBolt[0]->setTexture("maps/thunderbB1.png");
-    this->thunderBolt[1]->setTexture("maps/thunderbB2.png");
-    this->thunderBolt[2]->setTexture("maps/thunderbB3.png");
-    this->thunderBolt[3]->setTexture("maps/thunderbB4.png");
+    this->thunderBolt[0]->setTexture("textures/thunderbB1.png");
+    this->thunderBolt[1]->setTexture("textures/thunderbB2.png");
+    this->thunderBolt[2]->setTexture("textures/thunderbB3.png");
+    this->thunderBolt[3]->setTexture("textures/thunderbB4.png");
   }
 
Index: /branches/data_fix/src/world_entities/weather_effects/snow_effect.cc
===================================================================
--- /branches/data_fix/src/world_entities/weather_effects/snow_effect.cc	(revision 10185)
+++ /branches/data_fix/src/world_entities/weather_effects/snow_effect.cc	(revision 10186)
@@ -107,5 +107,5 @@
   this->snowMove = false;
   this->particles = 12000;
-  this->texture = "maps/snow_flake_01_32x32.png";
+  this->texture = "textures/snow_flake_01_32x32.png";
   this->snowLife = 8;
   this->randomLife = 2;