Index: branches/data_fix/src/lib/graphics/importer/bsp/bsp_file.cc
===================================================================
--- branches/data_fix/src/lib/graphics/importer/bsp/bsp_file.cc	(revision 10187)
+++ branches/data_fix/src/lib/graphics/importer/bsp/bsp_file.cc	(revision 10190)
@@ -449,7 +449,7 @@
     //this->Materials[i]->setShininess(100.0);
    // this->Materials[i].mat->setTransparency(1.0);
-    this->Materials[i].mat->setDiffuseMap("pictures/ground.tga");
-    this->Materials[i].mat->setAmbientMap("pictures/ground.tga");
-    this->Materials[i].mat->setSpecularMap("pictures/ground.tga");
+    this->Materials[i].mat->setDiffuseMap("textures/ground.tga");
+    this->Materials[i].mat->setAmbientMap("textures/ground.tga");
+    this->Materials[i].mat->setSpecularMap("textures/ground.tga");
     this->Materials[i].alpha = false;
     this->Materials[i].animated = false;
@@ -596,7 +596,7 @@
     //this->Materials[i]->setShininess(100.0);
     //this->Materials[i].mat->setTransparency(1.0);
-    this->Materials[i].mat->setDiffuseMap("pictures/error_texture.png");
-    this->Materials[i].mat->setAmbientMap("pictures/error_texture.png");
-    this->Materials[i].mat->setSpecularMap("pictures/error_texture.png");
+    this->Materials[i].mat->setDiffuseMap("textures/error_texture.png");
+    this->Materials[i].mat->setAmbientMap("textures/error_texture.png");
+    this->Materials[i].mat->setSpecularMap("textures/error_texture.png");
     this->Materials[i].alpha = true;
     this->Materials[i].animated = false;
Index: branches/data_fix/src/lib/graphics/render2D/image_plane.cc
===================================================================
--- branches/data_fix/src/lib/graphics/render2D/image_plane.cc	(revision 10187)
+++ branches/data_fix/src/lib/graphics/render2D/image_plane.cc	(revision 10190)
@@ -59,5 +59,5 @@
 
   //this->setBindNode(this);
-  this->setTexture("pictures/error_texture.png");
+  this->setTexture("textures/error_texture.png");
 }
 
Index: branches/data_fix/src/orxonox.cc
===================================================================
--- branches/data_fix/src/orxonox.cc	(revision 10187)
+++ branches/data_fix/src/orxonox.cc	(revision 10190)
@@ -257,5 +257,5 @@
   GraphicsEngine::getInstance()->initFromPreferences();
 
-  std::string iconName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath("pictures/fighter-top-32x32.bmp");
+  std::string iconName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath("textures/fighter-top-32x32.bmp");
   if (!iconName.empty())
   {
Index: branches/data_fix/src/story_entities/game_world_data.cc
===================================================================
--- branches/data_fix/src/story_entities/game_world_data.cc	(revision 10187)
+++ branches/data_fix/src/story_entities/game_world_data.cc	(revision 10190)
@@ -160,5 +160,5 @@
     PRINTF(2)("no LoadScreen specified, loading default\n");
 
-    glmis->setBackgroundImage("pictures/load_screen.jpg");
+    glmis->setBackgroundImage("textures/load_screens/default.jpg");
     this->glmis->setMaximum(8);
     //     this->glmis->draw();
Index: branches/data_fix/src/world_entities/environments/mapped_water.cc
===================================================================
--- branches/data_fix/src/world_entities/environments/mapped_water.cc	(revision 10187)
+++ branches/data_fix/src/world_entities/environments/mapped_water.cc	(revision 10190)
@@ -162,7 +162,7 @@
   mat.setDiffuseMap(refrTex, 1);
   // load normal map
-  mat.setDiffuseMap("pictures/water_normalmap.bmp", GL_TEXTURE_2D, 2);
+  mat.setDiffuseMap("textures/water_normalmap.bmp", GL_TEXTURE_2D, 2);
   // load dudv map
-  mat.setDiffuseMap("pictures/water_dudvmap.bmp", GL_TEXTURE_2D, 3);
+  mat.setDiffuseMap("textures/water_dudvmap.bmp", GL_TEXTURE_2D, 3);
 
   // sets texture parameters for reflection texture
Index: branches/data_fix/src/world_entities/skysphere.cc
===================================================================
--- branches/data_fix/src/world_entities/skysphere.cc	(revision 10187)
+++ branches/data_fix/src/world_entities/skysphere.cc	(revision 10190)
@@ -43,5 +43,5 @@
   this->toList(OM_BACKGROUND);
   if (fileName == NULL)
-    this->initialize("pictures/sky-replace.jpg");
+    this->initialize("textures/sky-replace.jpg");
   else
     this->initialize(fileName);